require "time_common/version"
require "time"

module TimeCommon
  class Error < StandardError; end
  # Your code goes here...
=begin
  date formats:

  Tue 3/31/2020 05:50 PM ET

  3/31/2020 05:50 PM ET

  3/31/2020

  3/31/2020

  3/31/2020 14:30

  March 28, 2020 11:59 PT

  3569 + 35498 (and strip , out )

  3/31/2020 at noon
=end
  
  # TESTED
  def self.filter_days(time_str)
    time_str = time_str.sub(/Mon /i,'')
    time_str = time_str.sub(/Tue /i,'')
    time_str = time_str.sub(/Wed /i,'')
    time_str = time_str.sub(/Thu /i,'')
    time_str = time_str.sub(/Fri /i,'')
    time_str = time_str.sub(/Sat /i,'')
    time_str = time_str.sub(/Sun /i,'')
    time_str = time_str.sub(/Monday /i,'')
    time_str = time_str.sub(/Tuesday /i,'')
    time_str = time_str.sub(/Wednesday /i,'')
    time_str = time_str.sub(/Thursday /i,'')
    time_str = time_str.sub(/Friday /i,'')
    time_str = time_str.sub(/Saturday /i,'')
    time_str = time_str.sub(/Sunday /i,'')
    time_str
  end

  # TESTED
  #DateTime.parse("3/31/2020 14:30")
  def self.parse(time_str)
    #byebug
    begin
      dt = DateTime.parse(time_str)
    rescue #Error => e
      time_str = TimeCommon.filter_days(time_str)
      #byebug
      if time_str =~ /([0-9]+)\/([0-9]+)\/(\d\d\d\d|20)/
        year = $3
        day = $2
        month = $1
        dt = DateTime.new(year.to_i,month.to_i,day.to_i)
      end
    end
    dt
  end



  # TimeCommon.merge_date_and_time("2019-10-16", "14:41:38")
  def self.merge_date_and_time(date, time)
    year, month, day = date.split("-")
    hour, minute, second = time.split(":")
    DateTime.new(year.to_i, month.to_i, day.to_i, hour.to_i, minute.to_i, second.to_i)
  end

  # TESTED
  def self.rough_time(time, user = nil)
    return "Late Night" if time.hour > 0 and time.hour < 6
    return "Morning" if time.hour >= 6 and time.hour < 12
    return "Afternoon" if time.hour >= 12 and time.hour < 18
    return "Evening" if time.hour >= 6 
    return 
  end

  # TESTED
  def self.wday_name(time)
    wday = time.wday
    return "Sunday" if wday == 0
    return "Monday" if wday == 1
    return "Tuesday" if wday == 2
    return "Wednesday" if wday == 3
    return "Thursday" if wday == 4
    return "Friday" if wday == 5
    return "Saturday" if wday == 6
  end


  def self.duration_since(time)
    duration = Time.now - time
    return (duration.seconds.to_f / 86400).round(0)
  end

  # TESTED
  #results["page_elements"]["course_updated"]
  #"Last updated 1/2017"
  def self.parse_updated(date_str, filter='Last updated ')
    date_str = date_str.sub(/#{filter}/,'')
    if date_str =~ /^([0-9]+)\/([0-9][0-9][0-9][0-9])$/
      month = $1
      day = 1
      year = $2
    elsif date_str =~ /^([0-9]+)\/([0-9]+)\/([0-9][0-9][0-9][0-9])$/
      month = $1
      day = $2
      year = $3
    end
    return Date.new(year.to_i,month.to_i,day.to_i)
  end

  # dispatcher routine
  def self.parse_all(time_str)
    return TimeCommon.parse_epoch(time_str) if time_str =~ /[0-9]{10,}/
    return TimeCommon.parse_utc(time_str)
  end

  def self.parse_epoch(time_str)
    begin
      return Time.at(time_str.to_i) if time_str =~ /[0-9]{10,}/
      raise TypeError
    rescue TypeError => e
      return Time.now
    end
  end

  # 
  def self.parse_utc(time_str)
    begin
      DateTime.parse(time_str)
    rescue Date::Error => e
      return Time.now
    end
  end
end
